/* Copyright (C) 1996,1997,1998, 1999, 2000, 2001, 2002  UPM-CLIP */

#include <sys/types.h>
#include <signal.h>
#include "compat.h"
#include "threads.h"
#include "datadefs.h"
#include "support.h"
#include "task_areas.h"

/* declarations for global functions accessed here */

#include "interrupt_defs.h"
#include "tasks_defs.h"
#include "start_defs.h"

/* local declarations */

static void abortmsg(int rc);


/* I/O predicate at ^C, else NULL */
/* Probably Shared, since only one worker should receive a ^C */
definition_t *int_address = NULL;

static void abortmsg PROTO((int rc));

static void interrupt_h(signal_number)
     int signal_number;
{
  /*WAMENV;*/
  Argdecl; 

  /*if (predicates_location != &user_predicates)*/
  
  if (!wam_initialized)                            /* wam not initialized */
    at_exit(-1);

  Arg = get_my_worker();

  Int_Heap_Warn = Heap_Start;
  SetEvent;
#if defined(LINUX)
/* From the manpage: Unlike on BSD systems, signals under Linux are reset to
  their default behavior when raised.  Therefore we have to SIGNAL()
  interrupt_h here again.  Be careful of restating which signals should
  interrupt_h respond to. */
#endif 
  if (int_address)
    LONGJMP(abort_env, -1); 
}

void control_c_normal(Arg)
     Argdecl;
{
  /*WAMENV;*/

  Int_Heap_Warn = Heap_Warn;
  if (Input_Stream_Ptr->isatty)
    SIGNAL(SIGINT,interrupt_h);
}


/* Non-control-C exception handling. --GB & MC */

void enable_conditions()
/* set system exception signal handling */
{
  SIGNAL(SIGFPE,  abortmsg);
  SIGNAL(SIGSEGV, abortmsg);
  SIGNAL(SIGILL,  abortmsg);
  SIGNAL(SIGBUS,  abortmsg);
#if defined(LINUX)
  /* Signal handlers in LINUX must reinstall the handler for the signal */
#endif
#if !defined(LINUX)              /* No "bad systema call" signal in Linux */
  SIGNAL(SIGSYS, abortmsg);
#endif
}

static void abortmsg(rc)
     int rc;
{
  char message[1024];
  switch( rc )
    {
    case SIGINT:
      SERIOUS_FAULT("interrupted");
      break;
    case SIGFPE:
      SERIOUS_FAULT("floating point exception");
      break;
    case SIGSEGV:
      SERIOUS_FAULT("segmentation violation");
      break;
    case SIGILL:
      SERIOUS_FAULT("illegal instruction");
      break;
    case SIGBUS:
      SERIOUS_FAULT("bus error");
      break;
#if !defined(LINUX)
    case SIGSYS:
      SERIOUS_FAULT("bad system call arg");
      break;
#endif
    default:
      sprintf(message, "miscellaneous error condition: received signal number %d\n", rc);
      SERIOUS_FAULT(message);
      break;
      }
}


